summaryrefslogtreecommitdiff
path: root/source3
diff options
context:
space:
mode:
authorAndreas Schneider <asn@samba.org>2018-05-03 10:17:12 +0200
committerKarolin Seeger <kseeger@samba.org>2018-05-09 14:22:22 +0200
commitbb5cee36b67ca78d29474f6f33fab9372203b925 (patch)
tree758f3e76b1ff115d91fc8c66687b264151541c30 /source3
parent4a9c164d0abfa30db3f943d1224ca95d87fdf95a (diff)
downloadsamba-bb5cee36b67ca78d29474f6f33fab9372203b925.tar.gz
s3:smbspool: Fix cmdline argument handling
BUG: https://bugzilla.samba.org/show_bug.cgi?id=13417 Signed-off-by: Andreas Schneider <asn@samba.org> Reviewed-by: Alexander Bokovoy <ab@samba.org> (cherry picked from commit a753ccfd946aaad320977ae8c5f483f73077c3f8) Autobuild-User(v4-8-test): Karolin Seeger <kseeger@samba.org> Autobuild-Date(v4-8-test): Wed May 9 14:22:22 CEST 2018 on sn-devel-144
Diffstat (limited to 'source3')
-rw-r--r--source3/client/smbspool.c61
-rwxr-xr-xsource3/script/tests/test_smbspool.sh30
2 files changed, 72 insertions, 19 deletions
diff --git a/source3/client/smbspool.c b/source3/client/smbspool.c
index ff32baea204..d6e944d547c 100644
--- a/source3/client/smbspool.c
+++ b/source3/client/smbspool.c
@@ -100,6 +100,9 @@ main(int argc, /* I - Number of command-line arguments */
const char *dev_uri;
const char *config_file = NULL;
TALLOC_CTX *frame = talloc_stackframe();
+ bool device_uri_cmdline = false;
+ const char *print_file = NULL;
+ const char *print_copies = NULL;
int cmp;
int len;
@@ -119,7 +122,12 @@ main(int argc, /* I - Number of command-line arguments */
goto done;
}
- if (argc < 7 || argc > 8) {
+ /*
+ * We need at least 5 options if the DEVICE_URI is passed via an env
+ * variable and printing data comes via stdin.
+ * We don't accept more than 7 options in total, including optional.
+ */
+ if (argc < 5 || argc > 8) {
fprintf(stderr,
"Usage: %s [DEVICE_URI] job-id user title copies options [file]\n"
" The DEVICE_URI environment variable can also contain the\n"
@@ -131,37 +139,52 @@ main(int argc, /* I - Number of command-line arguments */
}
/*
- * If we have 7 arguments, print the file named on the command-line.
- * Otherwise, print data from stdin...
- */
-
+ * If we have 6 arguments find out if we have the device_uri from the
+ * command line or the print data
+ */
if (argc == 7) {
- /*
- * Print from Copy stdin to a temporary file...
- */
+ cmp = strncmp(argv[1], "smb://", 6);
+ if (cmp == 0) {
+ device_uri_cmdline = true;
+ } else {
+ print_copies = argv[4];
+ print_file = argv[6];
+ }
+ } else if (argc == 8) {
+ device_uri_cmdline = true;
+ print_copies = argv[5];
+ print_file = argv[7];
+ }
- fp = stdin;
- copies = 1;
- } else if ((fp = fopen(argv[7], "rb")) == NULL) {
- perror("ERROR: Unable to open print file");
- goto done;
- } else {
- char *p = argv[5];
+ if (print_file != NULL) {
char *endp;
- copies = strtol(p, &endp, 10);
- if (p == endp) {
+ fp = fopen(print_file, "rb");
+ if (fp == NULL) {
+ perror("ERROR: Unable to open print file");
+ goto done;
+ }
+
+ copies = strtol(print_copies, &endp, 10);
+ if (print_copies == endp) {
perror("ERROR: Unable to determine number of copies");
goto done;
}
+ } else {
+ fp = stdin;
+ copies = 1;
}
/*
* Find the URI ...
*/
- dev_uri = getenv("DEVICE_URI");
- if (dev_uri == NULL || strlen(dev_uri) == 0) {
+ if (device_uri_cmdline) {
dev_uri = argv[1];
+ } else {
+ dev_uri = getenv("DEVICE_URI");
+ if (dev_uri == NULL || strlen(dev_uri) == 0) {
+ dev_uri = "";
+ }
}
cmp = strncmp(dev_uri, "smb://", 6);
diff --git a/source3/script/tests/test_smbspool.sh b/source3/script/tests/test_smbspool.sh
index 8f9426f87ba..899b34d0e40 100755
--- a/source3/script/tests/test_smbspool.sh
+++ b/source3/script/tests/test_smbspool.sh
@@ -139,6 +139,36 @@ testit "vlp verify example.ps" \
test_vlp_verify \
|| failed=$(expr $failed + 1)
+testit "smbspool print example.ps via stdin" \
+ $samba_smbspool smb://$USERNAME:$PASSWORD@$SERVER_IP/print1 200 $USERNAME "Testprint" 1 "options" < $SRCDIR/testdata/printing/example.ps || \
+ failed=$(expr $failed + 1)
+
+testit "vlp verify example.ps" \
+ test_vlp_verify \
+ || failed=$(expr $failed + 1)
+
+DEVICE_URI="smb://$USERNAME:$PASSWORD@$SERVER_IP/print1"
+export DEVICE_URI
+testit "smbspool print DEVICE_URI example.ps" \
+ $samba_smbspool 200 $USERNAME "Testprint" 1 "options" $SRCDIR/testdata/printing/example.ps || \
+ failed=$(expr $failed + 1)
+unset DEVICE_URI
+
+testit "vlp verify example.ps" \
+ test_vlp_verify \
+ || failed=$(expr $failed + 1)
+
+DEVICE_URI="smb://$USERNAME:$PASSWORD@$SERVER_IP/print1"
+export DEVICE_URI
+testit "smbspool print DEVICE_URI example.ps via stdin" \
+ $samba_smbspool 200 $USERNAME "Testprint" 1 "options" < $SRCDIR/testdata/printing/example.ps || \
+ failed=$(expr $failed + 1)
+unset DEVICE_URI
+
+testit "vlp verify example.ps" \
+ test_vlp_verify \
+ || failed=$(expr $failed + 1)
+
AUTH_INFO_REQUIRED="username,password"
export AUTH_INFO_REQUIRED
testit "smbspool_krb5(username,password) print example.ps" \